This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours

Bug 678662

Summary: Keymapping problems on International Apple Aluminium keyboard (Belgian Azerty)
Product: [Fedora] Fedora Reporter: info <info>
Component: xkeyboard-configAssignee: Peter Hutterer <peter.hutterer>
Status: CLOSED EOL QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: unspecified    
Version: 20CC: peter.hutterer
Target Milestone: ---Keywords: Reopened, Triaged
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-06-29 07:35:55 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Attachments:
Description Flags
Picture of apple aluminium keyboard AZERTY international
none
Output of evemu-desc /dev/input/by-id/usb-Apple__Inc_Apple_Keyboard-event-kbd
none
Output of evemu-desc /dev/input/by-id/usb-Apple__Inc_Apple_Keyboard-event-if01
none
Output of evemu-record when hitting the key in between LTAB and ESC
none
Output of evemu-record when hitting the key in between LTAB and ESC with shift key pressed
none
Output of evemu-record when hitting the key next to LSHIFT
none
Output of evemu-record when hitting the key next to LSHIFT with shift key pressed none

Description info@kobaltwit.be 2011-02-18 15:08:07 EST
Description of problem:
I have got an Apple Aluminium keyboard I'd like to use with Fedora 14. It mostly works except for a few keys. I'm running KDE and my keyboard layout is Belgian Azerty al the time. Here is what I experience:
* Regardless of the hardware type I choose for the keyboard, two keys are switched:
The key between the Esc key and the Tab key should give a "²", but instead gives a "<". The "<" key which the first key next to the left shift key, gives a "²" when hit. So these keys seem to be wired in reverse on an Aluminium keyboard.
* Should this be fixed, (so that "<" and ">" can be entered properly with the key next the LSHIFT) there is still a second issue with the key between ESC and TAB. The "²" and "³" values it gives are what a typical PC Azerty keyboard shows on that key. The apple keyboard on the other hand represents a "@" (lowercase) and "#" (uppercase) on that key in Azerty. This is the same on my Macbook pro by the way. So the key should give different results when an Apple keyboard is selected.
* Brings us to the issue of the hardware type. When the generic PC 105 hardware type is selected, things work fine, except for the first problem I described. However when I select the Apple Aluminium keyboard (ANSI or ISO) I loose my function keys or their multimedia equivalents.

Perhaps I can give some more details about the function keys on the apple keyboard. By default these keys return a number of media keycodes:
F7 is equivalent to "Previous track"
F8 is equivalent to "Play/Pause"
F9 is equivalent to "Next track"
F10 is equivalent to "Mute/Unmute"
F11 is equivalent to "Reduce Volume"
F12 is equivalent to "Increase Volume"
These work fine in Generic PC 105 mode. There are some others that don't work:
F1 is equivalent to "Reduce brightness"
F2 is equivalent to "Increase brightness"
F3 is an Apple specific mode to show all open windows (KDE has some equivalent feature, but I don't know about Gnome)
F4 is an Apple specific mode to open the Dashboard

Anyway, if you want to get a real function key, you need to press the "Fn" key, which on the Azerty Aluminium keyboard is located where the "Insert" key is on a traditional PC keyboard. This works fine with Generic PC 105 hardware type. With the Apple Aluminium hardware type, it doesn't. I have no clue where this problem starts.

Version-Release number of selected component (if applicable):
xkeyboard-config-1.9-7.fc14.noarch

How reproducible:
Always
For the switched keys, you need a physical Apple Aluminium keyboard. When you 
In either Gnome or KDE, set the keyboard model to Apple Aluminium (ISO), the layout to Belgian, standard Variant.

Steps to Reproduce:
1. For the switched keys, you need a physical Apple Aluminium keyboard. When you have one, you can reproduce simply by hitting the two keys I mentioned.
2. For the other issue, you can set the keyboard model to Apple Aluminium (ISO) and the layout to Belgian, standard Variant. Try to use the function keys. This won't work (not on a PC keyboard nor on the Apple Aluminium keyboard).

Additional info:
I can provide you with whatever details you still need to get this fixed. I'm not sure what info is useful, so I'll wait for your query.
Comment 1 Peter Hutterer 2012-01-15 20:29:00 EST
Can you please check if this bug is still present in F15 or F16, Fedora 14 has since been EOL'd (sorry about the silence for this long).
Comment 2 info@kobaltwit.be 2012-01-23 16:32:46 EST
Created attachment 557078 [details]
Picture of apple aluminium keyboard AZERTY international

I'm currently running Fedora 16, fully updated. Parts have been fixed, other parts are still not ok.

I have attached a picture of the keyboard. Perhaps this helps to visualize the issues.

1. The key right next to LSHIFT is still switched with the key between ESC and TAB. This means that if I type on the key next to LSHIFT it outputs "²" (without shift) or "³" (with shift). If I type on the key between ESC and TAB, it outputs "<" or ">". Note that is only for the aluminium keyboard. I have it attached to a MacBook Pro while running these tests, and on that keyboard the keys are not switched, regardless of the hardware type I choose.

2. The second issue is also still valid: instead of "²" and "³" that key should output "@" (without shift) or "#" (with shift).

3. But the function keys continue to work now when I select the "Apple Aluminium Keyboard" and press the "Fn" key. That's good, thank you !

4. Of the "multimedia" keys only "Mute/Unmute", "Volume Up" and "Volume Down" are working. "Previous track", "Play/Pause", "Next track", "Reduce brightness","Increase brightness" and the others are not.
Comment 3 Peter Hutterer 2012-06-26 01:51:17 EDT
ok, thanks. can you please record each key that's not working as a separate file with evemu-record? I need to replay those locally to check what is broken.
I also need the evemu-describe output. Thanks.
Comment 4 Peter Hutterer 2012-10-08 19:34:53 EDT
3+ months in NEEDINFO, closing. Please reopen when the requested information was provided.
Comment 5 info@kobaltwit.be 2012-10-27 08:51:46 EDT
It took me a while to get back to this. I am not using the apple keyboard in my day to day activities due to the key issues. I will attach the requested files below.

Note that I am using
evemu-record /dev/input/by-id/usb-Apple__Inc_Apple_Keyboard-event-kbd

There is a seconde id created when the keyboard is plugged in:
usb-Apple__Inc_Apple_Keyboard-event-if01

I'm not sure what that one is about. I'll attach the output of evemu-description for both device paths.
Comment 6 info@kobaltwit.be 2012-10-27 08:53:11 EDT
Created attachment 634182 [details]
Output of evemu-desc /dev/input/by-id/usb-Apple__Inc_Apple_Keyboard-event-kbd
Comment 7 info@kobaltwit.be 2012-10-27 08:53:44 EDT
Created attachment 634183 [details]
Output of evemu-desc /dev/input/by-id/usb-Apple__Inc_Apple_Keyboard-event-if01
Comment 8 info@kobaltwit.be 2012-10-27 08:56:26 EDT
Created attachment 634184 [details]
Output of evemu-record when hitting the key in between LTAB and ESC
Comment 9 info@kobaltwit.be 2012-10-27 08:57:45 EDT
Created attachment 634185 [details]
Output of evemu-record when hitting the key in between LTAB and ESC with shift key pressed

I'm not sure if this matters, but I've run the previous test again, this time with the shift key pressed as well.
Comment 10 info@kobaltwit.be 2012-10-27 08:59:16 EDT
Created attachment 634186 [details]
Output of evemu-record when hitting the key next to LSHIFT
Comment 11 info@kobaltwit.be 2012-10-27 09:00:17 EDT
Created attachment 634187 [details]
Output of evemu-record when hitting the key next to LSHIFT with shift key pressed

I'm not sure if this matters, but I've run the previous test again, this time with the shift key pressed as well.
Comment 12 info@kobaltwit.be 2012-10-27 09:08:55 EDT
Of the above tests, here's the character that is output (wrong) and the character that should be output (correct):

File                | wrong | correct |
---------------------------------------
Attachement 634184  |   <   |    @    |
Attachement 634185  |   >   |    #    |
Attachement 634186  |   ²   |    <    |
Attachement 634187  |   ³   |    >    |

These tests have been run on F16, fully up to date. I don't know if this matters, but the version of xkeyboard-config is currently 2.3-3.fc16.noarch.
Comment 13 info@kobaltwit.be 2012-10-27 09:20:23 EDT
I decided to run the tests on Fedora 17 as well. The evemu-record outputs seem exactly the same for this keyboard.

Is this information sufficient for you to work on these two swapped keys ?

If so, I'll also generate similar files for the multimedia keys that don't work properly. Otherwise, please let me know what else you need.
Comment 14 Fedora End Of Life 2013-02-13 21:11:07 EST
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 15 info@kobaltwit.be 2013-02-14 05:40:34 EST
As I mentioned in comment 13, I can reproduce this issue in Fedora 17, so I'm reopening this bug.
Comment 16 Fedora End Of Life 2013-07-04 02:25:28 EDT
This message is a reminder that Fedora 17 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 17. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '17'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 17's end of life.

Bug Reporter:  Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 17 is end of life. If you 
would still like  to see this bug fixed and are able to reproduce it 
against a later version  of Fedora, you are encouraged  change the 
'version' to a later Fedora version prior to Fedora 17's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 17 info@kobaltwit.be 2013-07-04 03:18:15 EDT
This is still an issue with Fedora 18.
Comment 18 Fedora End Of Life 2013-12-21 09:54:45 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 19 Fedora End Of Life 2014-02-05 17:40:27 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 20 info@kobaltwit.be 2014-02-18 07:12:18 EST
Still reproducible in Fedora 20. Reopening...
Comment 21 info@kobaltwit.be 2014-02-18 07:18:15 EST
In more detail:

* The swapped '³²' and '<>' key is still unresolved.
* The key between "tab" and "escape" which on a typical PC-105 keyboard is '²³' should be '#@' for an Apple Aluminium (Intl) keyboard
* Brighten/Dim screen (on the F1 and F2 keys) is not working
 
There are some improvements though.
* Switching between function keys and media keys does work
Comment 22 info@kobaltwit.be 2014-02-18 07:21:00 EST
Actually no, ignore my previous comment. I was apparently testing in the pc-105 setting (forgot to apply keyboard settings).

All of the issues are still there when selecting Apple Aluminium keyboard model in kde.
Comment 23 Fedora End Of Life 2015-05-29 04:38:31 EDT
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 24 Fedora End Of Life 2015-06-29 07:35:55 EDT
Fedora 20 changed to end-of-life (EOL) status on 2015-06-23. Fedora 20 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.